<!DOCTYPE html>
<!-- [QPRTemplateStart: sc_periodhierarchyview.tpl] -->
<html>
  <head>
    <title><#Title></title>
    <meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1">
    <meta http-equiv="content-type" content="text/html;charset=<#CHARSET>">
    <#PortalScript>
    <#stylesheet>
<script type="text/javascript">
var _iIndex = 0;
var _iExtraRows = 3, _iExtraCols = 1; // If you change these, remenber to change the values in 
                                      // QuickSelectPeriodData - tag parameters below
                                      // correspondingly
var _sActionData = sDecodeURI("<#QuickSelectPeriodData ExtraRows="3" ExtraCols="1">"); // If modifying, make sure the parameter values are equal to the values defined above.

function WriteQuickSelectionHardCodedPeriods()
{
  if (!bCheckVersion())
    return;

  ReadSeparator();
  var iColWidth = 25;

  document.write('<tr>');
  document.write('<td width = "' + iColWidth + '%">');
  document.write('<a href="javascript:FSubmitPeriod(\'default\', 0, \'\')"><#LocalizedText id="Default"></a>');
  document.write('</td>');    
  for (iCol = 0; iCol < 2; ++iCol) {
    document.write('<td width = "' + iColWidth + '%">');
    iPeriodId = sReadText();
    sLabel = sReadText();
    sDate = sReadText();
    ReadSeparator();
    document.write('<a href="javascript:FSubmitPeriod(\'' + sLabel + '\', ' + iPeriodId + ', \'' + sDate + '\')">' + sLabel + '</a>');
    document.write('</td>');
  }
  document.write('</tr>');
  
  document.write('<tr>');
  for (iCol = 0; iCol < 3; ++iCol) {
    document.write('<td width = "' + iColWidth + '%">');
    iPeriodId = sReadText();
    sLabel = sReadText();
    sDate = sReadText();
    ReadSeparator();
    document.write('<a href="javascript:FSubmitPeriod(\'' + sLabel + '\', ' + iPeriodId + ', \'' + sDate + '\')">' + sLabel + '</a>');
    document.write('</td>');
  }
  document.write('</tr>');

  for (; iCol < (_iExtraCols * 2 + 1); ++iCol) {
    document.write('<td width = "' + iColWidth + '%"></td>');
  }

  document.write('<tr><td colspan="4">&nbsp;</td></tr>');
}

function WriteQuickSelectionRows()
{
  var iRow, iCol, sLabel, iPeriodId, sDate;
  var iColWidth = parseInt(100 / ((_iExtraCols * 2) + 1));

  document.write('<tr>');
  for (iCol = 0; iCol < (_iExtraCols * 2 + 1); ++iCol) {
    document.write('<td class="ItemTitle">');
    sLabel = sReadText();
    ReadSeparator();
    document.write(sLabel);
    document.write('</td>');
  }
  document.write('</tr>');

  for (iRow = 0; iRow < (_iExtraRows * 2 + 1); ++iRow) {
    document.write('<tr>');

    for (iCol = 0; iCol < (_iExtraCols * 2 + 1); ++iCol) {
      iPeriodId = sReadText();
      sLabel = sReadText();
      sDate = sReadText();
      ReadSeparator();

      document.write('<td>');

      if (sLabel != '') {
        if ((iCol == _iExtraCols) && (iRow == _iExtraRows)) 
          document.write('<a class="SelectedButton">' + sLabel + '</a>');
        else
          document.write('<a href="javascript:FSubmitPeriod(\'' + sLabel + '\', ' + iPeriodId + ', \'' + sDate + '\')">' + sLabel + '</a>');
      }
      document.write('</td>');
    }
    document.write('</tr>');
  }
}
</script>

  </head> 
   
  <body class="PopupView" onLoad="OnLoad();">
    <script>
      ResizePopupWindow(300, 758);
      self.parent.document.title = document.title;
    </script>
    <form name="periodselection" action="" method="post">
      <div id="PopupHeader">
        <img src="<#PortalImageFileLocation>header_icon_select.png" />
        <h1>
          <#LocalizedText id="Select Period">
        </h1>
      </div>
      <div class="PopupContent">
        <table class="GroupedPropertyForm" cellpadding="0" cellspacing="0" border="0">
          <tr>
            <td colspan="2">
              <div class="PropertyFormGroupWrapper">
                <table class="GlossyPropertyFormGroup" cellspacing="0" cellpadding="0" width="100%">
                  <caption>
                    <#LocalizedText id="Quick Selection">
                  </caption>
                  <tr>
                    <td>
                      <table border="0" cellspacing="0" cellpadding="0" width="90%" align="center">
                        <script>
                          WriteQuickSelectionHardCodedPeriods();
                          WriteQuickSelectionRows();
                        </script>
                      </table>
                    </td>
                  </tr>
                </table>
              </div>
            </td>
          </tr>        
          <tr>
            <td width="50%">
              <div class="PropertyFormGroupWrapper">
                <table class="GlossyPropertyFormGroup" cellspacing="0" cellpadding="0" width="100%">
                  <caption>
                    <#LocalizedText id="Select Period Level">
                  </caption>
                  <tr height="100%">
                    <td>
                      <select name="lstPeriodLevels" size="19" style="width: 100%" onChange="OnPeriodLevelSelectChanged()" />
                    </td>
                  </tr>
                </table>
              </div>
            </td>
            <td width="50%">
              <div class="PropertyFormGroupWrapper">
                <table class="GlossyPropertyFormGroup" cellspacing="0" cellpadding="0" width="100%">
                  <caption>
                    <#LocalizedText id="Select Period">
                  </caption>
                  <tr height="100%">
                    <td>
                      <select name="lstPeriods" size="19" style="width: 100%" onDblClick="OnPeriodDoubleClicked();" />
                    </td>
                  </tr>
                </table>
              </div>
            </td>
          </tr>
        </table>
      </div>
      <div id="DetailsFooter">
        <input class="ButtonRight" type="button" value="<#LocalizedText id="Help">" onclick="OpenHelpWindow('<#HelpFileURL>?periodselectionview.htm')">
        <input class="ButtonRight" type="button" value="<#LocalizedText id="Cancel">" onclick="parent.window.close()">
        <input class="ButtonRight" type="button" value="<#LocalizedText id="OK">" onclick="OnClose()">
      </div>
    </form>
  </body>

<script>
var _arPeriodLevels, _iSelectedPeriodLevelIndex, _iPrevSelectedPeriodLevelIndex = -1;

function UpdateHierarchyParameters(vsParameters)
{
  if ((parent) && bHasValidOpener(parent.window) && (parent.opener.UpdateHierarchyParameters)) {
    parent.opener.UpdateHierarchyParameters(vsParameters);
  }
  parent.close();
}
   
function FSubmitPeriod(vsLabel, viID, vsDate)
{
  if (parent && bHasValidOpener(parent.window) && bExists(parent.window.opener.SetPeriodDate))   {
    parent.window.opener.SetPeriodDate(vsDate);
    parent.close();
    return;
  }

  if (parent && bHasValidOpener(parent.window) && bExists(parent.window.opener.OnPeriodHierarchyClosed)) {
    parent.window.opener.OnPeriodHierarchyClosed(vsLabel, viID, vsDate);
    parent.close();
    return;
  }

  if(parent && parent.opener.FSubmitPeriod) {
    parent.opener.FSubmitPeriod(viID);
    parent.close();
  }
  else
  {
    var oView = parent.opener.parent.InformationView;
    if (oView && oView.bHasDetailsPane())
      oView = oView.oGetView();
    if (oView) 
    {
      if (bExists(oView.submitPeriod))
        oView.submitPeriod(viID, vsDate);
      else
        oView.<#UserFrameName>.submitPeriod(viID, vsDate);
    }
    parent.close();
  }
}

function OnPeriodLevelSelectChanged()
{
  var undefined;
  if (!_arPeriodLevels)
    return;

  if (_iPrevSelectedPeriodLevelIndex != -1) {
    var oPeriodLevel = _arPeriodLevels[_iPrevSelectedPeriodLevelIndex];
    if (oPeriodLevel != undefined) {
      oPeriodLevel.piSelectedIndex = document.periodselection.lstPeriods.selectedIndex;
    }
  }

  var iSelectedIndex = document.periodselection.lstPeriodLevels.selectedIndex;
  var oPeriodLevel = _arPeriodLevels[iSelectedIndex];
  if (oPeriodLevel != undefined) {
    if (!oPeriodLevel.parPeriods) {
      var oList = document.periodselection.lstPeriods;
      var oParentNode = oList.parentNode;
      oParentNode.removeChild(oList);

      oList.options.length = 0;

      oParentNode.appendChild(oList);

      oList.options[oList.options.length] = new Option(sDecodeURI('<#LocalizedText enc="js" id="Loading...">'));
      document.periodselection.lstPeriodLevels.disabled = true;
      parent.callFunction('<#GetPeriodDataURL>&PLEV=' + oPeriodLevel.psId, OnPeriodDataLoaded);
    }
    else {
      RefreshPeriodList();
    }
    _iPrevSelectedPeriodLevelIndex = iSelectedIndex;
  }
}

function OnLoad()
{
  var oList = document.periodselection.lstPeriodLevels;
  oList.options[oList.options.length] = new Option(sDecodeURI('<#LocalizedText enc="js" id="Loading...">'));

  parent.callFunction('<#GetPeriodDataURL>', OnPeriodLevelDataLoaded);
  AdjustViewSelectionPopupWindowSize();
  // Google Analytics
  oGetMainView().sendGoogleAnalyticsEvent('Button', 'Period selection', '');  
}

function sNormOpt(sListOptionName)
{
  return sAutoCutString(sEncodeURI(sListOptionName), 30, true);
}

function RefreshPeriodLevelList()
{
  if (!_arPeriodLevels)
    return;

  var oList = document.periodselection.lstPeriodLevels;
  oList.options.length = 0;
  var oPeriodLevel, oOptions = oList.options, iNumPeriodLevels = _arPeriodLevels.length;

  for (var i = 0; i < iNumPeriodLevels; ++i) {
    oPeriodLevel = _arPeriodLevels[i];
    oOptions[i] = new Option(sNormOpt(oPeriodLevel.psPrettyName), oPeriodLevel.psId, (i == _iSelectedPeriodLevelIndex), (i == _iSelectedPeriodLevelIndex));
  }
}

var _iCurIndex, _n, _oList, _oParentNode, _oPeriodLevel;
var TIMEOUT = 1, CHUNK_SIZE = 8;

function AddChunkOfOptions()
{
  var arPeriods = _oPeriodLevel.parPeriods;
  var oPeriod = arPeriods[_iCurIndex], oOptions = _oList.options;

  var i = CHUNK_SIZE;
  do {
    oOptions[_iCurIndex] = new Option(sNormOpt(oPeriod.psPrettyName), oPeriod.psId + ";" + oPeriod.psDate);
    ++_iCurIndex;
    oPeriod = arPeriods[_iCurIndex];
    oOptions[_iCurIndex] = new Option(sNormOpt(oPeriod.psPrettyName), oPeriod.psId + ";" + oPeriod.psDate);
    ++_iCurIndex;
    oPeriod = arPeriods[_iCurIndex];
    oOptions[_iCurIndex] = new Option(sNormOpt(oPeriod.psPrettyName), oPeriod.psId + ";" + oPeriod.psDate);
    ++_iCurIndex;
    oPeriod = arPeriods[_iCurIndex];
    oOptions[_iCurIndex] = new Option(sNormOpt(oPeriod.psPrettyName), oPeriod.psId + ";" + oPeriod.psDate);
    ++_iCurIndex;
    oPeriod = arPeriods[_iCurIndex];
    oOptions[_iCurIndex] = new Option(sNormOpt(oPeriod.psPrettyName), oPeriod.psId + ";" + oPeriod.psDate);
    ++_iCurIndex;
    oPeriod = arPeriods[_iCurIndex];
    oOptions[_iCurIndex] = new Option(sNormOpt(oPeriod.psPrettyName), oPeriod.psId + ";" + oPeriod.psDate);
    ++_iCurIndex;
    oPeriod = arPeriods[_iCurIndex];
    oOptions[_iCurIndex] = new Option(sNormOpt(oPeriod.psPrettyName), oPeriod.psId + ";" + oPeriod.psDate);
    ++_iCurIndex;
    oPeriod = arPeriods[_iCurIndex];
    oOptions[_iCurIndex] = new Option(sNormOpt(oPeriod.psPrettyName), oPeriod.psId + ";" + oPeriod.psDate);
    ++_iCurIndex;
    oPeriod = arPeriods[_iCurIndex];
  } while ((--_n) && (--i));

  if (_n)
    window.setTimeout(AddChunkOfOptions, TIMEOUT);
  else {
    _oList.selectedIndex = _oPeriodLevel.piSelectedIndex;
    _oParentNode.appendChild(_oList);
  }
}

function RefreshPeriodList()
{
  if (!_arPeriodLevels)
    return;

  _oPeriodLevel = _arPeriodLevels[document.periodselection.lstPeriodLevels.selectedIndex];
  _oList = document.periodselection.lstPeriods;
  _oParentNode = _oList.parentNode;
  _oParentNode.removeChild(_oList);

  _oList.options.length = 0;

  var arPeriods = _oPeriodLevel.parPeriods;
  var oPeriod, oOptions = _oList.options, iNumPeriods = arPeriods.length;

  var n = iNumPeriods % 8; // Duff's device (http://www.lysator.liu.se/c/duffs-device.html) for optimizing loop
  _iCurIndex = 0;
  if (n > 0) {
    do {
      oPeriod = arPeriods[_iCurIndex];
      oOptions[_iCurIndex] = new Option(sNormOpt(oPeriod.psPrettyName), oPeriod.psId + ";" + oPeriod.psDate);
      ++_iCurIndex;
    }
    while (--n);
  }

  _n = parseInt(iNumPeriods / 8);
  if (_n > 0)
    AddChunkOfOptions();
  else {
    _oList.selectedIndex = _oPeriodLevel.piSelectedIndex;
    _oParentNode.appendChild(_oList);
  }
}

function OnPeriodLevelDataLoaded(result, data)
{
  if (!(result == "OK") && (data.length > 0))
  {
    window.alert(data);
    return;
  }

  _sActionData = data;
  _iIndex = 0;

  if (!bCheckVersion()) return;
  ReadSeparator();

  _arPeriodLevels = new Array();
  _iSelectedPeriodLevelIndex = sReadText();
  _iPrevSelectedPeriodLevelIndex = _iSelectedPeriodLevelIndex;

  var iNumPeriodLevels = sReadText(), oPeriodLevel;
  ReadSeparator();

  var i = iNumPeriodLevels;
  do {
    _arPeriodLevels[iNumPeriodLevels - i] = {
      psId : sReadText(),
      psPrettyName : sDecodeURI(sReadText()),
      psDate : ""
    }
    ReadSeparator();
  } while (--i);

  RefreshPeriodLevelList();
  OnPeriodLevelSelectChanged();
}

var _oArray;

function AddChunkOfPeriods()
{
  var i = CHUNK_SIZE;
  do {
    _oArray[++_iCurIndex] = {
      psId : sReadText(),
      psPrettyName : sDecodeURI(sReadText()),
      psDate : sReadText()
    }
    ReadSeparator();
    _oArray[++_iCurIndex] = {
      psId : sReadText(),
      psPrettyName : sDecodeURI(sReadText()),
      psDate : sReadText()
    }
    ReadSeparator();
    _oArray[++_iCurIndex] = {
      psId : sReadText(),
      psPrettyName : sDecodeURI(sReadText()),
      psDate : sReadText()
    }
    ReadSeparator();
    _oArray[++_iCurIndex] = {
      psId : sReadText(),
      psPrettyName : sDecodeURI(sReadText()),
      psDate : sReadText()
    }
    ReadSeparator();
    _oArray[++_iCurIndex] = {
      psId : sReadText(),
      psPrettyName : sDecodeURI(sReadText()),
      psDate : sReadText()
    }
    ReadSeparator();
    _oArray[++_iCurIndex] = {
      psId : sReadText(),
      psPrettyName : sDecodeURI(sReadText()),
      psDate : sReadText()
    }
    ReadSeparator();
    _oArray[++_iCurIndex] = {
      psId : sReadText(),
      psPrettyName : sDecodeURI(sReadText()),
      psDate : sReadText()
    }
    ReadSeparator();
    _oArray[++_iCurIndex] = {
      psId : sReadText(),
      psPrettyName : sDecodeURI(sReadText()),
      psDate : sReadText()
    }
    ReadSeparator();
  } while ((--_n) && (--i));

  if (_n)
    window.setTimeout(AddChunkOfPeriods, TIMEOUT);
  else {
    RefreshPeriodList()
    document.periodselection.lstPeriodLevels.disabled = false;
  }
}

function OnPeriodDataLoaded(result, data)
{
  if (!(result == "OK") && (data.length > 0))
  {
    var sMessage = sDecodeURI(data);
    window.alert(sMessage);
    OnLoad();
    return;
  }
  _sActionData = data;
  _iIndex = 0;

  if (!bCheckVersion()) return;
  ReadSeparator();

  var iPeriodLevel = document.periodselection.lstPeriodLevels.selectedIndex;
  var oPeriodLevel = _arPeriodLevels[iPeriodLevel];
  oPeriodLevel.piSelectedIndex = sReadText();

  var iNumPeriods = sReadText();
  ReadSeparator();

  _oArray = new Array();
  oPeriodLevel.parPeriods = _oArray;

  var n = iNumPeriods % 8; // Duff's device (http://www.lysator.liu.se/c/duffs-device.html) for optimizing loop
  _iCurIndex = -1;

  if (n > 0) {
    do {
      _oArray[++_iCurIndex] = {
        psId : sReadText(),
        psPrettyName : sDecodeURI(sReadText()),
        psDate : sReadText()
      }
      ReadSeparator();
    } while (--n);
  }

  _n = parseInt(iNumPeriods / 8);
  if (_n > 0)
    AddChunkOfPeriods();
  else {
    RefreshPeriodList()
    document.periodselection.lstPeriodLevels.disabled = false;
  }
}

function OnPeriodDoubleClicked()
{
  OnClose();
}

function OnClose()
{
  var oList = document.periodselection.lstPeriods;
  if (oList.selectedIndex != -1) {
    var oSelected = oList.options[oList.selectedIndex];
    var arData = oSelected.value.split(';');
    FSubmitPeriod(oSelected.text, arData[0], arData[1]);
  }
  else
    parent.window.close();
}
</script>
</html>
<!-- [QPRTemplateEnd: sc_periodhierarchyview.tpl] -->
