<!DOCTYPE html>
<!-- [QPRTemplateStart: modeldet.tpl] -->

<html>
<head>
<title><#Title></title>
<meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1">
<meta http-equiv="content-type" content="text/html;charset=<#CHARSET>">

<#PortalScript>
<link href="<#CSSFileLocation>booklet<#IsRTL true="_rtl">.css" rel="styleSheet" type="text/css" />

<script src="<#pgpluginjscriptfile>"></script>

<#Include template="jsportaltoolbarutils.tpl">

<script language="JavaScript" type="text/javascript">

// Header toolbar
function sGetProcessBrowserItem()
{
	sUrl = "";
	sItemText = "";
	bOpenInNew = false;
	iLevelId = 0;
	<#Tool_OpenInProcessBrowserParams>

	if(bOpenInNew){
		return sPGProcessOpenWindowLink(sUrl ,sItemText);
	}
	else {
		return sPGProcessInformationViewLinkWithId(sUrl ,sItemText,iLevelId);
	}
}

function sGetElementListItem()
{
	return sPGProcessInformationViewLink("<#Tool_ElementListUrl>","<#Tool_HElementList>");
}

function sGetHeaderHTML()
{
	return "<td NOWRAP align=\"right\">" + sGetProcessBrowserItem() + sGetElementListItem() + "</td>";
}

// Footer toolbar

function sGetFooterHTML()
{
  if (oGetHeaderView())
    return sGetDefaultToolbarButtons("<#ViewName>");
}

function sGetHelpFile()
{
	return "<#HelpFileURL>?detailview.htm";
}

</script>



</head> <!-- Google Analytics inside onload -->
<body onload="UpdateInformationViewToolbarsFromInformationView();trackGoogleAnalytics();" onUnload="UpdateInformationViewToolbarsFromInformationView();" topmargin="0" leftmargin="0" marginleft="0" margintop="0" marginwidth="0" marginheight="0">


<!--details_table-->
<table border="0" width="100%" cellpadding="2" cellspacing="1">

		<tr style="<#IsSectionVisible id="Name" false="display: none">" valign="bottom">
			<th width="33%" align="<#IsRTL true="left" false="right">"><b><#HModelName></b></th>
			<td colspan="2"><#ModelName></td>
		</tr>


		<tr style="<#IsSectionVisible id="Status" false="display: none">" valign="top">
			<th width="33%" align="<#IsRTL true="left" false="right">" class="BlackSubHeader"><b><#HStatus></b></th>
			<td colspan="2"><#Status></td>
		</tr>

		<tr style="<#IsSectionVisible id="Author" false="display: none">" valign="top">
			<th width="33%" align="<#IsRTL true="left" false="right">" class="BlackSubHeader"><b><#HAuthor></b></th>
			<td colspan="2"><#Author></td>
		</tr>

</table>

<br>

<table border="0" width="100%" cellpadding="2" cellspacing="1">

		<tr style="<#IsSectionVisible id="VersionNumber" false="display: none">" valign="top">
			<th width="33%" align="<#IsRTL true="left" false="right">" class="BlackSubHeader"><b><#HVersionNumber></b></th>
			<td colspan="2"><#VersionNumber></td>
		</tr>

		<tr style="<#IsSectionVisible id="Comment" false="display: none">" valign="top">
			<th width="33%" align="<#IsRTL true="left" false="right">" class="BlackSubHeader"><b><#HComment></b></th>
			<td colspan="2"><#Comment></td>
		</tr>

		<tr style="<#IsSectionVisible id="LastChanged" false="display: none">" valign="top">
			<th width="33%" align="<#IsRTL true="left" false="right">" class="BlackSubHeader"><b><#HLastChanged></b></th>
			<td colspan="2"><#LastChanged></td>
		</tr>
</table>

<br>

<table border="0" width="100%" cellpadding="2" cellspacing="1">

		<tr style="<#IsSectionVisible id="CreationDate" false="display: none">" valign="top">
			<th width="33%" align="<#IsRTL true="left" false="right">" class="BlackSubHeader"><b><#HCreationDate></b></th>
			<td colspan="2"><#CreationDate></td>
		</tr>

		<tr style="<#IsSectionVisible id="LastSaved" false="display: none">" valign="top">
			<th width="33%" align="<#IsRTL true="left" false="right">" class="BlackSubHeader"><b><#HLastSaved></b></th>
			<td colspan="2"><#LastSaved></td>
		</tr>
</table>


<#BeginSection id="InformationItems">
<br>

<table border="0" width="100%" cellpadding="0" cellspacing="1"><tr><td>
<!--info items-->
	<table border="0" width="100%" cellspacing="1" cellpadding="0">
		<tr <#Valign id="InformationItems">>
			<th width="33%" align="<#IsRTL true="left" false="right">"><b><#HInformationItems></b></th>
			<td colspan="2">
				<table border="0" width="100%" cellpadding="2" cellspacing="1">
					<#InformationItems style="2" template="">
					<!--cell template sample is tablerow_singlecell.tpl-->
				</table>
			</td>
		</tr>
	</table>
</td></tr></table>
<#EndSection>

<table border="0" width="100%" bgcolor="white" cellpadding="0" cellspacing="1">
	<tr><td>
		<table border="0" width="100%" cellpadding="2" cellspacing="1" bgcolor="white">
			<tr><td height="10" bgcolor="white" class="Betweencellgroups"><font size="-5">&nbsp;</font></td></tr>
		</table>
	</td></tr>
</table>

<!-- remove this line if you want to show incoming flows
<#BeginSection id="IncomingFlows">
<table border="0" width="100%" bgcolor="white" cellpadding="0" cellspacing="1"><tr><td>
	<table border="0" cellpadding="0" cellspacing="1" width="100%" bgcolor="white">

		<tr valign="top">
			<th width="33%" align="<#IsRTL true="left" false="right">" bgcolor="#CCCCCC" class="MainC"><b class="MainC1st"><#HIncomingFlows></b></th>
			<td colspan="2" bgcolor="white">
				<table border="0" width="100%" cellpadding="2" cellspacing="1">
					<tr>
						<th width="33%" class="BlackSubHeader"><#HFlow></th>
						<th width="33%" class="BlackSubHeader"><#HFrom></th>
					</tr>
					<#ModelIncomingFlows template="">
				</table>
			</td>
		</tr>
	</table>
</td></tr></table>

<table border="0" width="100%" bgcolor="white" cellpadding="0" cellspacing="1">
	<tr><td>
		<table border="0" width="100%" cellpadding="2" cellspacing="1" bgcolor="white">
			<tr><td height="10" bgcolor="white" class="Betweencellgroups"><font size="-5">&nbsp;</font></td></tr>
		</table>
	</td></tr>
</table>
<#EndSection>
remove this line if you want to show incoming flows-->

<!-- remove this line if you want to show outgoing flows
<#BeginSection id="OutgoingFlows">
<table border="0" width="100%" bgcolor="white" cellpadding="0" cellspacing="1"><tr><td>
	<table border="0" cellpadding="0" cellspacing="1" width="100%" bgcolor="white">
		<tr valign="top">
			<th width="33%" align="<#IsRTL true="left" false="right">"  bgcolor="#CCCCCC" class="MainC"><b class="MainC1st"><#HOutgoingFlows></b></th>
			<td colspan="2" bgcolor="white">
				<table border="0" width="100%" cellpadding="2" cellspacing="1">
					<tr>
						<th width="33%" class="BlackSubHeader"><#HFlow></th>
						<th width="33%" class="BlackSubHeader"><#HTo></th>
					</tr>
					<#ModelOutgoingFlows template="">
				</table>
			</td>
		</tr>
	</table>
</td></tr></table>

<table border="0" width="100%" bgcolor="white" cellpadding="0" cellspacing="1">
	<tr><td>
		<table border="0" width="100%" cellpadding="2" cellspacing="1" bgcolor="white">
			<tr><td height="10" bgcolor="white" class="Betweencellgroups"><font size="-5">&nbsp;</font></td></tr>
		</table>
	</td></tr>
</table>
<#EndSection>
remove this line if you want to show outgoing flows-->

<table border="0" width="100%" cellpadding="0" cellspacing="1"><tr><td>
	<table border="0" width="100%" cellpadding="2" cellspacing="1">
		<tr valign="bottom">
 			<td width="100%" align="<#IsRTL true="left" false="right">"><small><#PGVersionInfo></small></td>
		</tr>
	</table>
</td></tr></table>

</body>
</html>
<!-- [QPRTemplateEnd: modeldet.tpl] -->
